import java.util.LinkedList;
import java.util.ArrayList;

class CountWall{
	LinkedList<Integer> allrows; // toutes les rangées possibles d'une largeur fixée
	Table memo; // table de hachage pour la mémoïsation

	/** constructeur : mur de briques de largeur width */
	CountWall(int width) {

    // On prépare un tableau où la case i va contenir toutes les rangées de longueur i
		ArrayList<LinkedList<Integer>> rows = new ArrayList<LinkedList<Integer>>(width + 1);
    // On commence par remplir toutes les cases avec la liste vide
		for(int i = 0; i <= width; i++) 
      rows.add(new LinkedList<Integer>());
		// Puis on les édite.

		// les premières valeurs sont particulières
    // pour les longueur 0 et 1, il n'y a aucune rangée possible; on ne fait rien
    // pour les longueur 2 et 3, il y a exactement une rangée possible: 0 
    rows.get(2).add(0);
		rows.get(3).add(0);
		// pour les autres longueurs, une ligne de briques commence par une brique de longueur 2 ou 3
		for(int i = 4; i <= width; i++) {
			// si la première brique est de longueur 2, la ligne restante a longueur i-2
			for(Integer x: rows.get(i-2)) {
				rows.get(i).add((1 | x) << 2); //
			}
			// si la première brique est de longueur 3, la ligne restante a longueur i-3
			for(Integer x: rows.get(i-3)) {
				rows.get(i).add((1 | x) << 3);
			}
		}
		this.allrows = rows.get(width);
		this.memo = new Table(); 
	}

	/** count(row, height) : compte les murs de hauteur height dont la première rangée est row */
	long count(Integer row, int height) {
		if(height == 1) return 1;
		Triple t = memo.find(row, height);
		if(t != null) return t.result;
		long sum = 0;
		for(Integer s: allrows) {
			if((row & s) == 0) sum += count(s, height-1);
		}
		memo.add(row, height, sum);
		return sum;
	}

	/** count(height) : compte tous les murs de hauteur height */
	long count(int height) {
		long sum = 0;
		for(Integer row: allrows) {
			sum += count(row, height);
		}
		return sum;
	}


}
