import java.util.LinkedList;
@SuppressWarnings({"unchecked"})

class Table {
	final static int M = 5003;
    LinkedList<Triple> buckets[];

    /** constructeur */
    Table() {
        this.buckets = new LinkedList[M]; // ne pas écrire <Triple> ici
        for(int i = 0; i < M; i++) {
        	this.buckets[i] = new LinkedList<Triple>();
        }
    }
    
    /** calcule le code d'une clé */
    int hashCode(int x, int y) {
    	return (x+1)*(y+1);
    }
    
    /** donne la position d'une clé dans le tableau buskets */
    int bucket(int x, int y) {
    	int res = hashCode(x,y) % M;
    	return (res >= 0 ? res : M+res);
    }
    
    /** insérer un nouvel élément */
    void add(int x, int y, long r) {
    	this.buckets[bucket(x,y)].push(new Triple(x,y,r));
    }
    
    /** trouver l'élément correspondant à une clé */
    Triple find(int x, int y) {
    	for(Triple t: this.buckets[bucket(x,y)]) {
    		if(t.x == x && t.y == y) return t;
    	}
    	return null;
    }
    
    /** test */
    public static void main(String args[]) {
        Table t = new Table();
        System.out.println(t.find(1,2));
        t.add(1,2,3);
        t.add(17,23,42);
        System.out.println(t.find(1,2).result);
        System.out.println(t.find(1,3));
        System.out.println(t.find(17,23).result);
    }
}
